#pragma reqlib "scxp ibm"
#if !defined AMXMODX_NOAUTOLOAD
  #pragma loadlib "scxp ibm"
#endif
#include <amxmodx>
#include <fakemeta>
#include <scxpmod_const>

/**************************
 *        FORWARDS        *
 **************************/

 /**
 * refresh at per second
 */
forward xp_timer();

/**
 * Called when scxp mod is loaded
 */
forward xp_main();

/**
 * @param id			client id.
 * @param skid			skill id.
 * @noreturn
 */
forward xp_interval_invoked(id, skid, plclass);

 /**
 * @param id			client id.
 * @param plclass		player class id.
 * @noreturn
 */
forward xp_player_prethink(id, plclass);

 /**
 * @param id			client id.
 * @param plclass		player class id.
 * @noreturn
 */
forward xp_player_spawned(id, plclass);

 /**
 * @param id			client id.
 * @param plclass		player class id.
 * @param attacker		attacker id.
 * @param shouldgib		
 * @param plclass		player class id.
 * @noreturn
 */
forward xp_player_killed(id, plclass, attacker, shouldgib);

/**
 * @param id			client id.
 * @param skid			skill id.
 * @param plclass			player class id.
 * @noreturn
 */
forward xp_need_calc(id, skid, plclass);
/**
 * @param id			client id.
 * @param skid			skill id.
 * @param plclass			player class id.
 * @noreturn
 */
forward xp_need_reset(id, skid, plclass);
/**
 * @param id			client id.
 * @param plclass		player class id.
 * @param inflictor		
 * @param attacker	    attacker id
 * @param damage	    damage points
 * @param damagebits	damage type
 * @noreturn
 */
forward xp_player_takedamage(id, plclass, inflictor, attacker, Float:damage, damagebits);
/**
 * @param id			client id.
 * @param plclass		player class id.
 * @param inflictor		
 * @param attacker	    attacker id
 * @param damage	    damage points
 * @param damagebits	damage type
 * @noreturn
 */
forward xp_monster_takedamage(id, plclass, inflictor, attacker, Float:damage, damagebits);
forward xp_player_levelchanged(id, adminid, n_tpye, oldlevel, newlevel);
forward xp_player_selectskill(id, classid, skid);
forward xp_energy_valuechanged(id, oldvalue, newvalue);
forward xp_energy_used(id, canbeusenextime);
forward xp_energy_using_item(id, energyid);
forward xp_energy_canuseitem(id, energyid, hudmsg);

/**************************
 *        NATIVES         *
 **************************/

/**
 * Create a new skill
 * @return		True if sk added.
 */
native bool:xp_newskill(const strid[]);

/**
 * @return	Get user classid;
 */
native xp_get_userclass(userid);

/**
 * if you created a new skill, please use it.
 * Sets the skill variants.
 *
 * @return		True if skill applied.
 */
native bool:xp_setskill(classid, skid, ArrayData[]);

/**
 * @id		User id.
 * @skid		Skill id. If set -1, return player global level.
 * @return		User level.
 */
native xp_get_userlevel(id, skid = -1);

/**
 * @return		Get user required xp for next level.
 */
native xp_get_userreqxp(id);

/**
 * @return		Get user rakd id.
 */
native xp_get_userrankid(id);

/**
 * @return		Get user rank name.
 */
native xp_get_userrank(id, RankName[], ulen);
/**
 * @param id			client id.
 * @param skillid		skill id.
 * @param User_Level	playerlevel.
 * @return		Get user level efect point.
 */
native Float:xp_calcpoints(id, skillid, User_Level)
/**
 * @param id			client id.
 * @param skillid		skill id.
 * @param User_Level	playerlevel.
 * @return		Get user level radius.
 */
native Float:xp_calcradius(id, skillid, User_Level)

/**
 * @param id			client id.
 * @param skillid		skill id.
 * @param pevmax     	pev id
 * @return		Get user maximum value.
 */
native Float:xp_calcmax(id, skillid, pevmax)

/**
 * @return		if is player loggedin in return true
 */
native xp_isplayerloggedin(id);

/**
 * @return		if is player banned return true
 */
native xp_isplayerbanned(id);

/**
 * value return integer value
 * @noreturn		
 */
native xp_set(value);

/**
 * value return float value
 * @noreturn		
 */
native xp_setf(Float:value);
native xp_enabled();
native xp_refresh_player_hud(id);
native xp_energy_canuse(id);
native xp_energy_killcount(id);
native xp_energy_setkillcount(id, newvalue, settype, refreshhud);
native xp_energy_usedcount(id);
native xp_energy_setusedcount(id, newvalue, settype);
native xp_energy_enabled();
native xp_energy_maxkill();
native xp_energy_maxusage();
native xp_energy_use(id);
native xp_energy_register(energname[], energypoints, pointiscvar);